//
// Created by Иван_Архипов on 24.11.2017.
//

#ifndef LOTRO_DAT_LIBRARY_DDSSUBFILE_H
#define LOTRO_DAT_LIBRARY_DDSSUBFILE_H

#include "SubFile.h"

namespace LOTRO_DAT {
    class DdsSubFile : public SubFile {
    public:
        DdsSubFile() = delete;
        explicit DdsSubFile(const DdsSubFile &other) = delete;
        DdsSubFile &operator =(const DdsSubFile &other) = delete;

        DdsSubFile(DatFile &dat, long long dictionary_offset, long long fragments_count, long long unknown1,
                   long long file_id, long long file_offset, long long file_size, long long timestamp,
                   long long version, long long block_size);

        FILE_TYPE FileType() const override;

        std::string Extension() const override;

        SubfileData PrepareForExport(const BinaryData &file_data) override;

        BinaryData MakeForImport(const BinaryData &old_data, const SubfileData &data) override;
    };
};

#endif //LOTRO_DAT_LIBRARY_DDSSUBFILE_H
